#ifndef MEASUREMENTSYSTEM_H
#define MEASUREMENTSYSTEM_H

#include <stdint.h>
#include <cJSON.h>

//Modules
#include "RTCHelper.h"
#include "primaryBoardSensors.h"
#include "sensor.h"
#include "boardDefine.h"

//Initilses the internal sensor array to get everything ready
void MeasurementInit();

//Measure Specific Sensor
int MeasurementmeasureSensor(int sensorID);

//Get last measurement taken from the buffer
sensorMeasurement* MeasurementgetLastMeasurement();

//Get the tme of the next measurement
uint64_t MeasurementgetTimeofNextMeasurement();

//Returns number of measurements currently in the buffer based upon the measurementCount
int MeasurementgetCountofMeasuresinBuffer();

//Take all experied measurements
void MeasurementMeasureExpired();

//Get the latest measurements and outputs them into JSON. This doesn't erase the measurements
char* LatestToJson(void);

//Function for dumping measurements out to Json using cJSON
//Returned value must be cleared or were going to leak a fuck ton of memory
char* dumpMeasurementsToJson();

//Shell function to dump the measurement buffer to JSON for testing purposes
int __shell_Dump_Measurements_to_Json(const struct shell *sh, size_t argc, char **argv);

//Shell fucntion to measure the primary board sensors into the measurement array
int __shell_Measure_Primary_Board_Sensors(const struct shell *sh, size_t argc, char **argv);

//Returns the number of measurements currently in the buffer
int __shell_Measure_get_Count(const struct shell *sh, size_t argc, char **argv);

#endif