#ifndef BOARD_DEFINE_H
#define BOARD_DEFINE_H

#include <zephyr/drivers/gpio.h>

//Top-Level Measurement System Controls
#define MEASURMENT_MAX_BUFFER_FILL_SIZE 6 //Maxium number of measurements before the system must write the measurements to the cloud
#define ACTIVE_MEASUREMENT_SEASON_START -1 //Used to introduce calendar based behaviour differences (winter vs summer measurement intervals)
#define ACTIVE_MEASUREMENT_SEASON_END -1
#define MEASUREMENT_MAX_TIME_BETWEEN_CLOUD_UPDATES 86400

//Measurement Defines
#define MEASUREMENT_BUFFER_SIZE 150
#define SENSOR_COUNT 2
#define PRIMARY_BOARD_SENSOR_COUNT 2
#define MEASUREMENT_TIME_WIGGLE 60

//Measurement Type Definitions
#define _MEASUREMENT_VOLTAGE 'V'
#define _MEASUREMENT_TEMPERATURE 'T'

//Defines for primary board measurements
#define BATTERY_CHARGER_VBATT_SENSOR_ID 0
#define BATTERY_CHARGER_VSYS_SENSOR_ID 1
#define SYSTEM_VOLTAGE_MEASUREMENT_INTERVAL 600

//Other Board Defines
#define BOARD_IDENTIFIER "Prototype - ID01"

//RTC interupt Pins
static const struct gpio_dt_spec RTC_Alarm_GPIO_DT = GPIO_DT_SPEC_GET(DT_ALIAS(rtcint), gpios);
static struct gpio_callback RTC_Alarm_CB;

//Networking Stuff
#define THINGSBOARD_POST_ADDRESS "thingsboard.cloud"
#define THINGSBOARD_URL "/api/v1/cv6RxGrOoezj3vaqAYgp/telemetry" //This needs to be configurable properly. This should be removed post basic testing (HAS ACCESS KEY In IT!!)
#define RESPONSE_BUFFER_SIZE 500
#define THINGSBOARD_PORT 80

#endif